# Keyed List Example

[![Demo](https://img.shields.io/website?label=demo&url=https%3A%2F%2Fexamples.yew.rs%2Fkeyed_list)](https://examples.yew.rs/keyed_list)

This example consists of a list which can be manipulated in various ways.

### Notes

If you would like to view this example as a performance demonstation, run this example in `release` mode.

## Concepts

Demonstrates how using keyed elements improves the performance of comparing changes to lists.

## Improvements

- Improve the name and address generation so that they don't look like gibberish
- Show the time it took to update the DOM on the page instead of just the console
- Improve the presentation of the example with CSS

## Running

Run this application with the trunk development server:

```bash
RUSTFLAGS='--cfg getrandom_backend="wasm_js"' trunk serve --open
```
